<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.18 $
 * $Author: tora60 $
 * $Date: 2009/02/26 06:38:30 $
 *
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 * Based on Journey Links Hack
 * Copyright (c) 2000 by James Knickelbein
 * Journey Milwaukee (http://www.journeymilwaukee.com)
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref("radminlink")) {
    mxErrorScreen("Access Denied");
    die();
}

$module_name = basename(dirname(dirname(__FILE__)));
mxGetLangfile($module_name);
include('modules/' . $module_name . '/l_config.php');
include('modules/' . $module_name . '/includes/functions.php');

$wysiwyg = 0;
$wysiwyg_linx = 0;
$wysiwyg_comments = 0;
include_once('spaw/spaw_control.class.php');

/**
 * Beschreibung
 */
function codered($num)
{
    $num = (int)$num;
    if (!empty($num)) {
        $num = "<b><span style='color: Red; font-weight: bolder;'>" . $num . "</span></b>";
    }
    return $num;
}

/**
 * Beschreibung
 */
function modAdminMenu()
{
    global $prefix, $bgcolor2, $bgcolor1;
    $result = sql_query("select * from " . $prefix . "_links_modrequest where brokenlink=1");
    $totalbrokenlinks = sql_num_rows($result);
    $result2 = sql_query("select * from " . $prefix . "_links_modrequest where brokenlink=0");
    $totalmodrequests = sql_num_rows($result2);

    $men[] = "<a href=\"admin.php?op=LinksList\">" . _LISTALL . "</a>";
    $men[] = "<a href=\"admin.php?op=LinksConfig\">" . _PTITLEDLC . "</a>";
    $men[] = "<a href=\"admin.php?op=LinksLinkCheck\">" . _VALIDATELINKS . "</a>";
    if ($totalbrokenlinks)
        $men[] = "<a href=\"admin.php?op=LinksListBroken\">" . _BROKENLINKSREP . "</a>&nbsp;(" . codered($totalbrokenlinks) . ")";
    if ($totalmodrequests)
        $men[] = "<a href=\"admin.php?op=LinksListModRequests\">" . _LINKMODREQUEST . "</a>&nbsp;(" . codered($totalmodrequests) . ")";
    $men[] = "<a href=\"admin.php?op=LinksCleanVotes\">" . _CLEANLINKSDB . "</a>";

    OpenTable();
    echo "<center><font class=\"title\"><a href='admin.php?op=Links'><b>" . _WEBLINKSADMIN . "</b></a></font><br /><br /></center>";
    echo "<center><font class=\"content\">[&nbsp;<span style=\"white-space: nowrap;\">" . implode("</span> <small class=\"tiny\">|</small> <span style=\"white-space: nowrap;\">", $men) . "</span>&nbsp;]</font></center>";
    CloseTable();
    echo '<br />';
}

/**
 * List Active Links
 */
function modList()
{
    global $prefix, $module_name;

    $img_delete = mxCreateImage("modules/" . $module_name . "/images/delete.gif", _DELETE);
    $img_edit = mxCreateImage("modules/" . $module_name . "/images/edit.gif", _EDIT);
    $img_view = mxCreateImage("modules/" . $module_name . "/images/info.gif", _SHOW);
    $img_check = mxCreateImage("modules/" . $module_name . "/images/check.gif", _LINKVALIDATION);
    $cid = (empty($_GET['cid'])) ? 0 : intval($_GET['cid']);

    $result = sql_query("SELECT COUNT(lid) FROM " . $prefix . "_links_links");
    list($numrows) = sql_fetch_row($result);

    if (isset($_GET['cid'])) {
        $qry = "SELECT lid, title, url, date as updated, name, email, hits FROM " . $prefix . "_links_links WHERE cid=" . intval($cid) . " ORDER BY lid DESC";
    } else {
        $qry = "SELECT lid, title, url, date as updated, name, email, hits FROM " . $prefix . "_links_links ORDER BY lid DESC LIMIT 150";
    }
    $result = sql_query($qry);

    include ("header.php");
    GraphicAdmin();
    modAdminMenu();
    OpenTable();
    // echo '<center><font class="storycat"><b>' . $numrows . ' ' . _LINKSINDB . '</b></font></center>';
    $class = '';
    if ($numrows > 0) {
        echo '<center><a name="result" id="result"></a>'
         . '<form action="admin.php#result" name="jump" id="jump">' . _WLCATEGORIES . ':&nbsp;'
         . '<select name="cid" onchange="location.href=\'admin.php?op=LinksList&amp;cid=\' + document.jump.cid.options[document.jump.cid.options.selectedIndex].value + \'#result\'">'
         . '' . modGetCategoriesSelect($cid, 'showmain') . ''
         . '</select>&nbsp;<input type="submit" value="' . _SWITCHIT . '" />'
         . '<input type="hidden" name="op" value="LinksList" />'
         . '</form>'
         . '</center>'
         . '<br />';
        echo '
        	<table class="full list">
         		<thead>
         			<tr>
         				<th>' . _FILENAME . '</th>
         				<th>' . _WLAUTHOR . '</th>
         				<th>' . _DATE . '</th>
         				<th>' . _FUNCTIONS . '</th>
         				<th>' . _WLHITS . '</th>
         			</tr>
         		</thead>
         		<tbody>';
        while (list($lid, $title, $url, $date, $name, $email, $hits) = sql_fetch_row($result)) {
            /*
            if ($colorswitch == $bgcolor3) {
                $colorswitch = $bgcolor1;
            } else {
                $colorswitch = $bgcolor3;
            }*/
            $class = ($class == '') ? ' class="alternate-a"' : '';
            echo '
            		<tr' . $class . '>
             			<td><a href="' . $url . '">' . $title . '</a></td>
             			<td><a href="mailto:' . $email . '">' . $name . '</a></td>
             			<td>' . $date . '</td>
             			<td align="center">
             				<a href="modules.php?name=' . $module_name . '&amp;op=check&amp;url=' . urlencode($url) . '"' . modCheckPopupLink($url) . ' target="_blank">' . $img_check . '</a>
             				<a href="admin.php?op=LinksModData&amp;lid=' . $lid . '">' . $img_edit . '</a>
             				<a href="admin.php?op=LinksDelData&amp;lid=' . $lid . '">' . $img_delete . '</a>
             				<a href="modules.php?name=' . $module_name . '&amp;op=view&amp;lid=' . $lid . '">' . $img_view . '</a>
             			</td>
             			<td align="center">' . $hits . '</td>
             		</tr>';
        }
        echo '
        		</tbody>	
        	</table>';
    }
    CloseTable();
    // hier gleich noch die Kategorie bearbeiten lassen
    if (isset($_GET['cid'])) {
        $cid = intval($_REQUEST['cid']);
        $qry = "select cid, title, cdescription, parentid, captcha from " . $prefix . "_links_categories where cid=" . $cid;
        // mxDebugFuncVars($qry);
        $result = sql_query($qry);
        $cat = sql_fetch_assoc($result);
        if (!empty($cat['cid'])) {
            echo '<br />';
            OpenTable();
            echo "<fieldset><legend>" . _MODCATEGORY . "</legend>"
             . "<form method=\"post\" action=\"admin.php\">"
             . "<table border=\"0\">"
             . modCategoryForm($cat)
             . "<tr valign=\"top\"><td colspan=\"2\">
            <input type=\"hidden\" name=\"cid\" value=\"" . $cid . "\" />
            <input type=\"hidden\" name=\"op\" value=\"LinksModCatSave\" />
            <input type=\"submit\" value=\"" . _SAVECHANGES . "\" />
            &nbsp;&nbsp;&nbsp;[&nbsp;<a href=\"admin.php?op=LinksDelCat&amp;cid=" . $cid . "\">" . _DELETE . "</a>&nbsp;]
            </td></tr>"
             . "</table>"
             . "</form></fieldset>";
            CloseTable();
        }
    }
    include ("footer.php");
}

/**
 * Beschreibung
 */
function modAdminMain()
{
    global $prefix, $bgcolor2, $bgcolor1;
    include ("header.php");
    GraphicAdmin();
    modAdminMenu();

    /**
     * List Links waiting for validation
     */
    $result = sql_query("select lid, cid, title, url, description, ort, name as auth_name, email, submitter, updated from " . $prefix . "_links_newlink ORDER BY lid");
    $numrows = sql_num_rows($result);
    if ($numrows > 0) {
        $i = 0;
        OpenTable();
        echo "<center><font class=\"option\"><b>" . _LINKSWAITINGVAL . "</b></font></center><br />";
        while ($thisdata = sql_fetch_assoc($result)) {
            $i++;
            echo '<hr noshade="noshade" size="1" />'
             . "<form action=\"admin.php?op=LinksAddData\" method=\"post\" name=\"downform\">"
             . "<b>" . _NEW . " " . $i . ".</b><br /><br />"
             . "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
             . modDataForm($thisdata)
             . "<tr valign=\"top\"><td>&nbsp;</td><td><input type=\"checkbox\" name=\"addstory\" value=\"1\" />" . _WLADDSTORY . "</td></tr>"
             . "</table>"
             . "<input type=\"hidden\" name=\"new\" value=\"1\" />"
             . "<input type=\"hidden\" name=\"op\" value=\"LinksAddData\" />"
             . "<input type=\"submit\" value=\"" . _ADD . "\" /> [&nbsp;<a href=\"admin.php?op=LinksDelNew&amp;lid=" . $thisdata['lid'] . "\">" . _DELETE . "</a> ]"
             . "</form>";
        }
        CloseTable();
        echo '<br />';
    }
    // Add a New Link to Database
    $result = sql_query("select cid, title from " . $prefix . "_links_categories");
    $num_categories = sql_num_rows($result);
    if ($num_categories > 0) {
        OpenTable();
        echo '<a name="addnew" id="addnew"></a>';
        echo "<fieldset><legend>" . _ADDNEWLINK . "</legend>"
         . "<form method=\"post\" action=\"admin.php?op=LinksAddData\" name=\"downform\">"
         . "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
         . modDataForm()
         . "<tr valign=\"top\"><td>&nbsp;</td><td><input type=\"checkbox\" name=\"addstory\" value=\"1\" />" . _WLADDSTORY . "</td></tr>"
         . "</table>"
         . "<input type=\"hidden\" name=\"new\" value=\"0\" />"
         . "<input type=\"hidden\" name=\"op\" value=\"LinksAddData\" />"
         . "<input type=\"submit\" value=\"" . _ADDURL . "\" /><br />"
         . "</form>"
         . "</fieldset>";
        CloseTable();
        echo '<br />';
    }
    // Modify Links
    $result = sql_query("select lid from " . $prefix . "_links_links");
    $allnumrows = sql_num_rows($result);
    if ($allnumrows > 0) {
        OpenTable();
        echo "<fieldset><legend>" . _MODLINK . "</legend>"
         . "<form method=\"post\" action=\"admin.php\">"
         . "<span class=\"content\">" . _LINKID . "</span>: <input type=\"text\" name=\"lid\" size=\"12\" maxlength=\"11\" />&nbsp;&nbsp;"
         . "<input type=\"hidden\" name=\"op\" value=\"LinksModData\" />"
         . "<input type=\"submit\" value=\"" . _WLMODIFY . "\" />"
         . "</form></fieldset>";
        CloseTable();
        echo '<br />';
    }
    // Modify Category
    if ($num_categories > 0) {
        OpenTable();
        echo "<fieldset><legend>" . _MODCATEGORY . "</legend>"
         . "<form method=\"post\" action=\"admin.php\">";
        echo _WLCATEGORY . ": <select name=\"cid\">" . modGetCategoriesSelect(0) . "</select>"
         . "<input type=\"hidden\" name=\"op\" value=\"LinksModCat\" />"
         . "<input type=\"submit\" value=\"" . _WLMODIFY . "\" />"
         . "</form></fieldset>";
        CloseTable();
        echo '<br />';
    }
    // Add Category
    OpenTable();
    echo "<fieldset><legend>" . _WLADDSUBCATEGORY . "</legend>"
     . "<form method=\"post\" action=\"admin.php\">"
     . "<table border=\"0\">"
     . modCategoryForm()
     . "<tr valign=\"top\"><td colspan=\"2\"><input type=\"hidden\" name=\"op\" value=\"LinksAddCat\" /><input type=\"submit\" value=\"" . _ADD . "\" /></td></tr>"
     . "</table>"
     . "</form></fieldset>";
    CloseTable();
    echo '<br />';
    // Transfer Categories
    if ($allnumrows > 0 && $num_categories > 1) {
        OpenTable();
        echo "<form method=\"post\" action=\"admin.php\">"
         . "<font class=\"option\"><b>" . _WLTRANSFERLINKS . "</b></font><br /><br />"
         . "<table>"
         . "<tr><td>" . _WLCATEGORY . ": </td><td><select name=\"cidfrom\">" . modGetCategoriesSelect(0, 'showmain', 'hideemptycats') . "</select></td></tr>"
         . "<tr><td>" . _IN . "&nbsp;" . _WLCATEGORY . ": </td><td><select name=\"cidto\">" . modGetCategoriesSelect(0, 'showmain') . "</select></td></tr>"
         . "<tr><td colspan=\"2\"><input type=\"hidden\" name=\"op\" value=\"LinksTransfer\" />"
         . "<input type=\"submit\" value=\"" . _WLTRANSFER . "\" /></td></tr>"
         . "</table>"
         . "</form>";
        CloseTable();
        echo '<br />';
    }
    include ("footer.php");
}

/**
 * Beschreibung
 */
function modCategoryForm($cat = array())
{
    global $prefix;

    if ($GLOBALS['wysiwyg'] && $GLOBALS['wysiwyg_linx']) {
        $sw = new SPAW_Wysiwyg('cdescription', ((empty($cat['cdescription'])) ? '' : $cat['cdescription']), _DOC_LANGUAGE, 'mini', $GLOBALS['wysiwyg_btnset'], '100%', '130');
        $area = $sw->getHtml();
        $area = "<td colspan=\"2\">" . _WLDESCRIPTION . ":<br />" . $area . "</td>";
    } else {
        $area = "<textarea name=\"cdescription\" cols=\"60\" rows=\"10\">" . ((empty($cat['cdescription'])) ? '' : htmlspecialchars($cat['cdescription'])) . "</textarea>\n";
        $area = "<td>" . _WLDESCRIPTION . ":</td><td>" . $area . "</td>";
    }
    // $groupoptions = getAllAccessLevelSelectOptions($GLOBALS['default_group']);
    // mxDebugFuncVars($groupoptions);
    // _WLGROUPSEE, _WLGROUPDOWN
    $out = ""
     . "<tr valign=\"top\"><td>" . _NAME . ": </td><td><input type=\"text\" name=\"title\" size=\"60\" maxlength=\"100\" value=\"" . ((empty($cat['title'])) ? '' : htmlspecialchars($cat['title'])) . "\" /></td></tr>"
     . "<tr valign=\"top\"><td>" . _IN . "&nbsp;" . _WLCATEGORY . ":</td><td colspan=\"2\"><select name=\"parentid\">" . modGetCategoriesSelect(((empty($cat['parentid'])) ? 0 : intval($cat['parentid'])), 'showmain') . "</select></td></tr>"
     . "<tr valign=\"top\">" . $area . "</tr>"
    // . "<tr valign=\"top\"><td>" . _USERGROUPS . ":</td><td><select name=\"moveto_group\">" . $groupoptions . "</select></td></tr>"
    . "<tr valign=\"top\"><td>" . _WLUSECAPTCHA . "?</td><td>
     <input type=\"radio\" name=\"captcha\" value=\"1\"" . ((empty($cat['captcha'])) ? '' : ' checked="checked"') . ' />' . _YES . "&nbsp;
     <input type=\"radio\" name=\"captcha\" value=\"0\"" . ((empty($cat['captcha'])) ? ' checked="checked"' : '') . ' />' . _NO . "</td></tr>" ;
    return $out;
}

/**
 * Beschreibung
 */
function modModifyData($lid)
{
    global $prefix, $bgcolor2;
    $qry = "SELECT dd.*, dd.name as auth_name, dd.date as updated, dc.title AS ctitle, dc.parentid AS cparentid, de.linkid AS editorialid
        FROM " . $prefix . "_links_links AS dd
        LEFT JOIN " . $prefix . "_links_categories AS dc ON dd.cid = dc.cid
        LEFT JOIN " . $prefix . "_links_editorials AS de ON dd.lid = de.linkid
        WHERE dd.lid = " . intval($lid);
    $result = sql_query($qry);
    $row = sql_fetch_assoc($result);
    // falls die lid nicht existiert, abbrechen
    if (empty($row['lid'])) {
        mxErrorScreen('link id ' . intval($lid) . ' not found...');
    }
    include ("header.php");
    GraphicAdmin();
    modAdminMenu();
    OpenTable();
    modViewData($row, 'single', 'full');
    CloseTable();
    echo '<br />';
    OpenTable();
    echo "<fieldset><legend>" . _MODLINK . "</legend>";
    echo '<form action="admin.php?op=LinksModDataSave" method="post" name="downform" id="downform">'
     . "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
     . modDataForm($row)
     . "<tr valign=\"top\"><td colspan=\"2\" align=\"center\"><input type=\"hidden\" name=\"op\" value=\"modifyrequestsave\" />"
     . "<br /><br /><input type=\"submit\" value=\"" . _WLMODIFY . "\" /> [&nbsp;<a href=\"admin.php?op=LinksDelData&amp;lid=$lid\">" . _DELETE . "</a> ]</td></tr>"
     . "</table>"
     . "<input type=\"hidden\" name=\"op\" value=\"LinksModDataSave\" />"
     . "</form></fieldset>";
    CloseTable();
    echo '<br />';

    /**
     * Modify or Add Editorial
     */
    $resulted2 = sql_query("select adminid, editorialtimestamp, editorialtext, editorialtitle from " . $prefix . "_links_editorials where linkid=" . intval($lid));
    $recordexist = sql_num_rows($resulted2);
    if ($recordexist) {
        list($adminid, $editorialtimestamp, $editorialtext, $editorialtitle) = sql_fetch_row($resulted2);
        $formatted_date = formattimestamp($editorialtimestamp);
    }

    if ($GLOBALS['wysiwyg'] && $GLOBALS['wysiwyg_linx']) {
        $sw = new SPAW_Wysiwyg('editorialtext', ((empty($editorialtext)) ? "" : $editorialtext), _DOC_LANGUAGE, $GLOBALS['wysiwyg_toolbar'], $GLOBALS['wysiwyg_btnset'], '100%', '250');
        $area = $sw->getHtml();
    } else {
        $area = "<textarea name=\"editorialtext\" cols=\"60\" rows=\"15\">" . ((empty($editorialtext)) ? "" : htmlspecialchars($editorialtext)) . "</textarea>\n";
    }

    OpenTable();
    if ($recordexist) {
        echo "<center><font class=\"content\"><b>" . _MODEDITORIAL . "</b></font></center><br /><br />"
         . "<form action=\"admin.php\" method=\"post\">"
         . "<input type=\"hidden\" name=\"linkid\" value=\"$lid\" />"
         . "<input type=\"hidden\" name=\"op\" value=\"LinksModEditorial\" />"
         . _WLAUTHOR . ": $adminid<br />"
         . _DATEWRITTEN . ": $formatted_date<br /><br />"
         . _EDITORIALTITLE . ":<br /><input type=\"text\" name=\"editorialtitle\" value=\"" . mxEntityQuotes($editorialtitle) . "\" size=\"50\" maxlength=\"100\" /><br />"
         . _EDITORIALTEXT . ":<br />" . $area . '<br />'
         . "<input type=\"submit\" value=\"" . _MODEDITORIAL . "\" /> [&nbsp;<a href=\"admin.php?op=LinksDelEditorial&amp;linkid=$lid\">" . _DELETE . "</a>&nbsp;]";
    } else {
        echo "<fieldset><legend>" . _ADDEDITORIAL . "</legend>"
         . "<form action=\"admin.php\" method=\"post\">"
         . "<input type=\"hidden\" name=\"linkid\" value=\"$lid\" />"
         . "<input type=\"hidden\" name=\"op\" value=\"LinksAddEditorial\" />"
         . _EDITORIALTITLE . ":<br /><input type=\"text\" name=\"editorialtitle\" value=\"" . ((empty($editorialtitle)) ? "" : htmlspecialchars($editorialtitle)) . "\" size=\"50\" maxlength=\"100\" /><br />"
         . _EDITORIALTEXT . ":<br />" . $area . '<br />'
         . "<input type=\"submit\" value=\"" . _ADDEDITORIAL . "\" />"
         . "</form></fieldset>";
    }
    CloseTable();
    echo '<br />';

    /**
     * Show Comments
     */
    $result5 = sql_query("SELECT ratingdbid, ratinguser, ratingcomments, ratingtimestamp FROM " . $prefix . "_links_votedata WHERE ratinglid = " . intval($lid) . " AND ratingcomments != '' ORDER BY ratingtimestamp DESC");
    $totalcomments = sql_num_rows($result5);
    OpenTable();
    echo '<table width="100%" border="1">';
    echo "<tr><td colspan=7><b>" . _NUMOFCOMMENTS . " (" . _OFALL . ": $totalcomments)</b><br /><br /></td></tr>";
    if ($totalcomments == 0) {
        echo "<tr><td colspan=7><center>" . _LNOCOMMENTS . "<br /></center></td></tr>";
    } else {
        echo "<tr><td width=20 colspan=1><b>" . _USER . "</b></td><td colspan=5><b>" . _LCOMMENT . "</b></td><th>" . _DELETE . "</th></tr>";
        $x = 0;
        $colorswitch = $bgcolor2;
        while (list($ratingdbid, $ratinguser, $ratingcomments, $ratingtimestamp) = sql_fetch_row($result5)) {
            $formatted_date = formattimestamp($ratingtimestamp);
            echo "<tr style=\"background-color: $colorswitch;\"><td>$ratinguser</td><td colspan=5>$ratingcomments</td><td><center><b><a href=admin.php?op=LinksDelComment&amp;lid=$lid&amp;rid=$ratingdbid>X</a></b></center></td></tr>";
            $x++;
            $colorswitch = ($colorswitch == $bgcolor2) ? $bgcolor1 : $bgcolor2;
        }
    }
    // Show Registered Users Votes
    $result5 = sql_query("SELECT ratingdbid, ratinguser, rating, ratinghostname, ratingtimestamp FROM " . $prefix . "_links_votedata WHERE ratinglid = " . intval($lid) . " AND ratinguser != 'outside' AND ratinguser != '" . $GLOBALS['anonymous'] . "' ORDER BY ratingtimestamp DESC");
    $totalvotes = sql_num_rows($result5);
    echo "<tr><td colspan=7><br /><br /><b>" . _NOREGUSERSVOTES . " (" . _LTOTALVOTES . ": $totalvotes)</b><br /><br /></td></tr>";
    if ($totalvotes == 0) {
        echo "<tr><td colspan=7><center>" . _NOREGUSERSVOTES . "<br /></center></td></tr>";
    } else {
        echo "<tr><td><b>" . _USER . "</b></td><td><b>" . _WHONHOST1 . "</b></td><td><b>" . _RATING . "</b></td><td><b>" . _USERAVGRATING . "</b></td><td><b>" . _NUMBEROFRATINGS . "</b></td><td><b>" . _DATE . "</b></td><th>" . _DELETE . "</th></tr>";
        $x = 0;
        $colorswitch = $bgcolor2;
        while (list($ratingdbid, $ratinguser, $rating, $ratinghostname, $ratingtimestamp) = sql_fetch_row($result5)) {
            $formatted_date = formattimestamp($ratingtimestamp);
            // Individual user information
            $result2 = sql_query("SELECT rating FROM " . $prefix . "_links_votedata WHERE ratinguser = '$ratinguser'");
            $usertotalcomments = sql_num_rows($result2);
            $useravgrating = 0;
            while (list($rating2) = sql_fetch_row($result2)) {
                $useravgrating = $useravgrating + $rating2;
            }
            $useravgrating = $useravgrating / $usertotalcomments;
            $useravgrating = number_format($useravgrating, 1);
            echo "<tr style=\"background-color: $colorswitch;\"><td>$ratinguser</td><td>$ratinghostname</td><td>$rating</td><td>$useravgrating</td><td>$usertotalcomments</td><td>$formatted_date  </font></b></td><td><center><b><a href=admin.php?op=LinksDelVote&amp;lid=$lid&amp;rid=$ratingdbid>X</a></b></center></td></tr>";
            $x++;
            $colorswitch = ($colorswitch == "dddddd") ? "ffffff" : "dddddd";
        }
    }
    // Show Unregistered Users Votes
    $result5 = sql_query("SELECT ratingdbid, rating, ratinghostname, ratingtimestamp FROM " . $prefix . "_links_votedata WHERE ratinglid = " . intval($lid) . " AND ratinguser = '" . $GLOBALS['anonymous'] . "' ORDER BY ratingtimestamp DESC");
    $totalvotes = sql_num_rows($result5);
    echo "<tr><td colspan=7><b><br /><br />" . _UNREGUSERSVOTES . " (" . _LTOTALVOTES . ": $totalvotes)</b><br /><br /></td></tr>";
    if ($totalvotes == 0) {
        echo "<tr><td colspan=7><center>" . _NOUNREGUSERSVOTES . "<br /></center></td></tr>";
    } else {
        echo "<tr><td colspan=2><b>" . _WHONHOST1 . "</b></td><td colspan=3><b>" . _RATING . "</b></td><td><b>" . _DATE . "</b></font></td><th>" . _DELETE . "</th></tr>";
        $x = 0;
        $colorswitch = "dddddd";
        while (list($ratingdbid, $rating, $ratinghostname, $ratingtimestamp) = sql_fetch_row($result5)) {
            $formatted_date = formattimestamp($ratingtimestamp);
            echo "<tr style=\"background-color: $colorswitch;\"><td colspan=2>$ratinghostname</td><td colspan=3>$rating</td><td>$formatted_date  </font></b></td><td><center><b><a href=admin.php?op=LinksDelVote&amp;lid=$lid&amp;rid=$ratingdbid>X</a></b></center></td></tr>";
            $x++;
            $colorswitch = ($colorswitch == "dddddd") ? "ffffff" : "dddddd";
        }
    }
    // Show Outside Users Votes
    $result5 = sql_query("SELECT ratingdbid, rating, ratinghostname, ratingtimestamp FROM " . $prefix . "_links_votedata WHERE ratinglid = " . intval($lid) . " AND ratinguser = 'outside' ORDER BY ratingtimestamp DESC");
    $totalvotes = sql_num_rows($result5);
    echo "<tr><td colspan=7><b><br /><br />" . _OUTSIDEVOTERS . " (" . _LTOTALVOTES . ": $totalvotes)</b><br /><br /></td></tr>";
    if ($totalvotes == 0) {
        echo "<tr><td colspan=7><center>" . _NOOUTSIDEVOTES . " " . $GLOBALS['sitename'] . "<br /></center></td></tr>";
    } else {
        echo "<tr><td colspan=2><b>" . _WHONHOST1 . "</b></td><td colspan=3><b>" . _RATING . "</b></td><td><b>" . _DATE . "</b></td><th>" . _DELETE . "</th></tr>";
        $x = 0;
        $colorswitch = "dddddd";
        while (list($ratingdbid, $rating, $ratinghostname, $ratingtimestamp) = sql_fetch_row($result5)) {
            $formatted_date = formattimestamp($ratingtimestamp);
            echo "<tr style=\"background-color: $colorswitch;\"><td colspan=2>$ratinghostname</td><td colspan=3>$rating</td><td>$formatted_date  </font></b></td><td><center><b><a href=admin.php?op=LinksDelVote&amp;lid=$lid&amp;rid=$ratingdbid>X</a></b></center></td></tr>";
            $x++;
            $colorswitch = ($colorswitch == "dddddd") ? "ffffff" : "dddddd";
        }
    }
    echo "</table>";
    CloseTable();
    echo '<br />';
    include ("footer.php");
}

/**
 * Beschreibung
 */
function modModifyDataSave()
{
    global $prefix;
    $_POST = modCheckData($_POST);
    $qry = "UPDATE " . $prefix . "_links_links SET
            cid=" . intval($_POST['cid']) . ",
            sid=0,
            title='" . mxAddSlashesForSQL($_POST['title']) . "',
            url='" . mxAddSlashesForSQL($_POST['url']) . "',
            description='" . mxAddSlashesForSQL($_POST['description']) . "',
			ort='" . mxAddSlashesForSQL($_POST['ort']) . "',
            name='" . mxAddSlashesForSQL($_POST['auth_name']) . "',
            email='" . mxAddSlashesForSQL($_POST['email']) . "',
            hits=" . intval($_POST['hits']) . ",
            submitter='" . mxAddSlashesForSQL($_POST['submitter']) . "',
            date='" . mxAddSlashesForSQL($_POST['updated']) . "'
            WHERE lid=" . intval($_POST['lid']);
    // mxDebugFuncVars($qry); exit;
    $result = sql_query($qry);
    if ($result) {
        mxRedirect('admin.php?op=LinksModData&lid=' . intval($_POST['lid']), _CHANGESAREOK);
    } else {
        mxErrorScreen('Database Error (modModifyDataSave)<br /><br />' . mysql_error());
    }
}

/**
 * Beschreibung
 */
function modDelComment($lid, $rid)
{
    global $prefix;
    sql_query("UPDATE " . $prefix . "_links_votedata SET ratingcomments='' WHERE ratingdbid = " . intval($rid));
    sql_query("UPDATE " . $prefix . "_links_links SET totalcomments = (totalcomments - 1) WHERE lid = " . intval($lid));
    mxRedirect('admin.php?op=LinksModData&lid=' . $lid, _CHANGESAREOK);
}

/**
 * Beschreibung
 */
function modDelVote($lid, $rid)
{
    global $prefix, $module_name;
    sql_query("delete from " . $prefix . "_links_votedata where ratingdbid=$rid");
    $voteresult = sql_query("select rating, ratinguser, ratingcomments FROM " . $prefix . "_links_votedata WHERE ratinglid = " . intval($lid));
    $totalvotesDB = sql_num_rows($voteresult);
    include ("modules/$module_name/includes/voteinclude.php");
    sql_query("UPDATE " . $prefix . "_links_links SET linkratingsummary=$finalrating,totalvotes=$totalvotesDB,totalcomments=$truecomments WHERE lid = " . intval($lid));
    mxRedirect('admin.php?op=LinksModData&lid=' . $lid, _CHANGESAREOK);
}

/**
 * Beschreibung
 */
function modListBroken()
{
    global $bgcolor1, $bgcolor2, $bgcolor3, $prefix, $user_prefix, $module_name;
    include ("header.php");
    GraphicAdmin();
    modAdminMenu();
    OpenTable();
    $result = sql_query("select requestid, lid, modifysubmitter from " . $prefix . "_links_modrequest where brokenlink=1 ORDER BY requestid");
    $totalbrokenlinks = sql_num_rows($result);
    echo '<center><font class="content"><b>' . _DUSERREPBROKEN . ' (' . $totalbrokenlinks . ')</b></font></center>'
     . '<ul><li>' . _DIGNOREINFO . '</li><li>' . _DDELETEINFO . '</li></ul>';
    if ($totalbrokenlinks == 0) {
        echo '<center><font class="content">' . _DNOREPORTEDBROKEN . '</font></center><br /><br /><br />';
    } else {
        $colorswitch = $bgcolor3;
        $img_check = mxCreateImage("modules/" . $module_name . "/images/check.gif", _LINKVALIDATION);
        echo '<table width="100%" border="0" cellspacing="1" cellpadding="2" align="center" style="background-color: ' . $bgcolor2 . ';">'
         . '<tr style="background-color: ' . $colorswitch . ';">'
         . '<th colspan="2">' . _MODITEMS . '</th>'
         . '<th>' . _IGNORE . '</th>'
         . '<th>' . _DELETE . '</th>'
         . '<th>' . _EDIT . '</th>'
         . '<th>' . _WLSUBMITTER . '</th>'
         . '<th>' . _LINKOWNER . '</th>'
         . '</tr>';
        while (list($requestid, $lid, $modifysubmitter) = sql_fetch_row($result)) {
            if ($colorswitch == $bgcolor3) {
                $colorswitch = $bgcolor1;
            } else {
                $colorswitch = $bgcolor3;
            }
            $result2 = sql_query("select title, url, submitter from " . $prefix . "_links_links where lid=" . intval($lid));
            if ($modifysubmitter != $GLOBALS['anonymous']) {
                $result3 = sql_query("select email from " . $user_prefix . "_users where uname='" . mxAddSlashesForSQL($modifysubmitter) . "'");
                list($email) = sql_fetch_row($result3);
            }
            list($title, $url, $owner) = sql_fetch_row($result2);
            $result4 = sql_query("select email from " . $user_prefix . "_users where uname='" . mxAddSlashesForSQL($owner) . "'");
            list($owneremail) = sql_fetch_row($result4);
            if (!empty($email)) {
                $modifysubmitter = "<a href=\"mailto:$email\">$modifysubmitter</a>";
            }
            if (!empty($owneremail)) {
                $owner = "<a href=\"mailto:$owneremail\">$owner</a>";
            }
            echo '<tr style="background-color: ' . $colorswitch . ';">'
             . '<td><a href="' . $url . '">' . $title . '</a></td>'
             . '<td width="1%"><a href="modules.php?name=' . $module_name . '&amp;op=check&amp;url=' . urlencode($url) . '"' . modCheckPopupLink($url) . '>' . $img_check . '</a></td>'
             . '<td><center><a href="admin.php?op=LinksIgnoreBroken&amp;lid=' . $lid . '">X</a></center></td>'
             . '<td><center><a href="admin.php?op=LinksDelBroken&amp;lid=' . $lid . '">X</a></center></td>'
             . '<td><center><a href="admin.php?op=LinksModData&amp;lid=' . $lid . '">X</a></center></td>'
             . '<td>&nbsp;' . $modifysubmitter . '</td>'
             . '<td>&nbsp;' . $owner . '</td>'
             . '</tr>';
        }
        echo "</table>";
    }
    CloseTable();
    include ("footer.php");
}

/**
 * Beschreibung
 */
function modDelBroken($lid)
{
    global $prefix;
    // mxDebugFuncVars($_REQUEST);
    $lid = (isset($_REQUEST['lid'])) ? intval($_REQUEST['lid']) : 0;
    if (!isset($_POST['okdelete'])) {
        $qry = "SELECT dd.*, dd.name as auth_name, dd.date as updated, dc.title AS ctitle, dc.parentid AS cparentid, de.linkid AS editorialid
            FROM " . $prefix . "_links_links AS dd
            LEFT JOIN " . $prefix . "_links_categories AS dc ON dd.cid = dc.cid
            LEFT JOIN " . $prefix . "_links_editorials AS de ON dd.lid = de.linkid
            WHERE dd.lid = " . intval($lid);
        $result = sql_query($qry);
        $row = sql_fetch_assoc($result);
        include("header.php");
        OpenTable();
        modViewData($row, 'single', 'full');
        CloseTable();
        echo '<br />';
        OpenTable();
        echo '<div align="center">' . _WLAREYOUSURE . '<br /><br />' . _DDELETEINFO . '<br /><br />
        <form action="admin.php?op=LinksDelBroken" method="post">
        <input type="hidden" name="op" value="LinksDelBroken" />
        <input type="hidden" name="lid" value="' . $lid . '" />
        <input type="submit" name="okdelete" value="' . _YES . '" />&nbsp;&nbsp;<input type="submit" name="okdelete" value="' . _NO . '" />
        </form></div>';
        CloseTable();
        include("footer.php");
    } else {
        if ($_POST['okdelete'] != _YES || empty($lid)) {
            mxRedirect('admin.php?op=LinksListBroken');
        } else {
            sql_query("delete from " . $prefix . "_links_links where lid=" . intval($lid));
            $notdeleted = modCheckAndCleanSubdata($lid);
            if ($notdeleted) {
                mxErrorScreen('Database Error (modDelBroken)<br /><br />' . mysql_error());
            } else {
                mxRedirect('admin.php?op=LinksListBroken', _WLDELETED);
            }
        }
    }
}

/**
 * Beschreibung
 */
function modIgnoreBroken($lid)
{
    global $prefix;
    $result = sql_query("delete from " . $prefix . "_links_modrequest where lid=" . intval($lid) . " and brokenlink=1");
    if ($result) {
        mxRedirect('admin.php?op=LinksListBroken', _CHANGESAREOK);
    } else {
        mxErrorScreen('Database Error (modIgnoreBroken)<br /><br />' . mysql_error());
    }
}

/**
 * Beschreibung
 */
function modListModRequests()
{
    global $bgcolor2, $prefix, $user_prefix;
    include ("header.php");
    GraphicAdmin();
    modAdminMenu();
    OpenTable();
    $result = sql_query("select requestid, lid, cid, title, url, description, ort, modifysubmitter, updated from " . $prefix . "_links_modrequest where brokenlink=0 ORDER BY requestid");
    $totalmodrequests = sql_num_rows($result);
    echo "<center><font class=\"content\"><b>" . _DUSERMODREQUEST . " ($totalmodrequests)</b></font></center><br /><br /><br />";
    echo "<table width=\"95%\"><tr><td>";
    while (list($requestid, $lid, $cid, $title, $url, $description, $ort, $modifysubmitter, $updated) = sql_fetch_row($result)) {
        $result2 = sql_query("select cid, title, url, description, name, email, submitter, date, ort as updated from " . $prefix . "_links_links where lid=$lid");
        list($origcid, $origtitle, $origurl, $origdescription, $origname, $origemail, $owner, $origort, $origupdated) = sql_fetch_row($result2);
        $result3 = sql_query("select title from " . $prefix . "_links_categories where cid=$cid");
        $result5 = sql_query("select title from " . $prefix . "_links_categories where cid=$origcid");
        $result7 = sql_query("select email from " . $user_prefix . "_users where uname='$modifysubmitter'");
        $result8 = sql_query("select email from " . $user_prefix . "_users where uname='$owner'");
        list($cidtitle) = sql_fetch_row($result3);
        list($origcidtitle) = sql_fetch_row($result5);
        list($modifysubmitteremail) = sql_fetch_row($result7);
        list($owneremail) = sql_fetch_row($result8);
        if ($owner == "") {
            $owner = "administration";
        }
        echo "<br /><table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\">"
         . "<tr>"
         . "<td>"
         . "<table width=\"100%\" cellpadding=\"3\" cellspacing=\"0\" style=\"background-color: $bgcolor2;\">"
         . "<tr>"
         . "<td valign=\"top\" width=\"45%\"><b>" . _WLORIGINAL . "</b></td>"
         . "<td rowspan=\"10\" valign=\"top\" align=\"left\"><font class=\"tiny\"><br />" . _WLDESCRIPTION . ":<br />$origdescription</font></td>"
         . "</tr>"
         . "<tr><td valign=\"top\" width=\"45%\"><font class=\"tiny\">" . _WLTITLE . ": $origtitle</font></td></tr>"
         . "<tr><td valign=\"top\" width=\"45%\"><font class=\"tiny\">" . _WLFILEURL . ": <a href=\"" . $origurl . "\">" . mxCutString($origurl, 45) . "</a></font></td></tr>"
		 . "<tr><td valign=\"top\" width=\"45%\"><font class=\"tiny\">" . _ORT . ": $origort</font></td></tr>"
        // . "<tr><td valign=\"top\" width=\"45%\"><font class=\"tiny\">"._WLCATEGORY.": $origcidtitle</font></td></tr>"
        . "<tr><td valign=\"top\" width=\"45%\"><font class=\"tiny\">" . _WLCATEGORY . ": $origcidtitle</font></td></tr>"
        // . "<tr><td valign=\"top\" width=\"45%\"><font class=\"tiny\">" . _WLAUTHORNAME . ": $origname</font></td></tr>"
        // . "<tr><td valign=\"top\" width=\"45%\"><font class=\"tiny\">" . _WLAUTHOREMAIL . ": $origemail</font></td></tr>"
        . "<tr><td valign=\"top\" width=\"45%\"><font class=\"tiny\">" . _LASTUPDATED . ": $origupdated</font></td></tr>"
         . "</table>"
         . "</td>"
         . "</tr>"
         . "<tr>"
         . "<td>"
         . "<table width=\"100%\" cellpadding=\"3\" cellspacing=\"0\">"
         . "<tr>"
         . "<td valign=\"top\" width=\"45%\"><b>" . _WLPROPOSED . "</b></td>"
         . "<td rowspan=\"10\" valign=\"top\" align=\"left\"><font class=\"tiny\"><br />" . _WLDESCRIPTION . ":<br />$description</font></td>"
         . "</tr>"
         . "<tr><td valign=\"top\" width=\"45%\"><font class=\"tiny\">" . _WLTITLE . ": $title</font></td></tr>"
         . "<tr><td valign=\"top\" width=\"45%\"><font class=\"tiny\">" . _WLFILEURL . ": <a href=\"" . $url . "\">" . mxCutString($url, 45) . "</a></font></td></tr>"
        // . "<tr><td valign=\"top\" width=\"45%\"><font class=\"tiny\">"._WLCATEGORY.": $cidtitle</font></td></tr>"
        . "<tr><td valign=\"top\" width=\"45%\"><font class=\"tiny\">" . _WLCATEGORY . ": $cidtitle</font></td></tr>"
        // . "<tr><td valign=\"top\" width=\"45%\"><font class=\"tiny\">" . _WLAUTHORNAME . ": $modifysubmitter</font></td></tr>"
        // . "<tr><td valign=\"top\" width=\"45%\"><font class=\"tiny\">" . _WLAUTHOREMAIL . ": $email</font></td></tr>"
        . "<tr><td valign=\"top\" width=\"45%\"><font class=\"tiny\">" . _LASTUPDATED . ": $updated</font></td></tr>"
         . "</table>"
         . "</td>"
         . "</tr>"
         . "</table>"

         . "<table width=\"100%\">"
         . "<tr><td align=\"left\"><font class=\"tiny\">" . _WLSUBMITTER . ":<br />";
        $modifysubmitter = ($modifysubmitter) ? $modifysubmitter : $GLOBALS['anonymous'];
        if ($modifysubmitteremail == "") {
            echo $modifysubmitter;
        } else {
            echo "<a href=\"mailto:$modifysubmitteremail\">$modifysubmitter</a>";
        }
        echo "</font></td><td align=\"left\"><font class=\"tiny\">" . _OWNER . ":<br />";
        if ($owneremail == "") {
            echo $owner;
        } else {
            echo "<a href=\"mailto:$owneremail\">$owner</a>";
        }
        echo "</font></td><td align=\"right\"><font class=\"tiny\">(
        <a href=\"admin.php?op=LinksChangeModRequests&amp;requestid=$requestid\">" . _ACCEPT . "</a> |
        <a href=\"admin.php?op=LinksChangeIgnoreRequests&amp;requestid=$requestid\">" . _IGNORE . "</a> |
        <a href=\"admin.php?op=LinksModData&amp;lid=" . $lid . "\">" . _EDITTHISLINK . "</a>
        )</font></td></tr>
        </table><br /><br />";
    }
    if ($totalmodrequests == 0) {
        echo "<center>" . _NOMODREQUESTS . '<br /><br />'
         . _GOBACK . "<br /><br /></center>";
    }
    echo "</td></tr></table>";
    CloseTable();
    include ("footer.php");
}

/**
 * Beschreibung
 */
function modChangeModRequests($requestid)
{
    global $prefix;
    $result = sql_query("select requestid, lid, cid, title, url, description, ort, updated from " . $prefix . "_links_modrequest where requestid=" . intval($requestid));
    list($requestid, $lid, $cid, $title, $url, $description, $updated) = sql_fetch_row($result);
    if (!empty($lid)) {
        $ok = sql_query("UPDATE " . $prefix . "_links_links SET
            cid=" . intval($cid) . ",
            sid=0,
            title='" . mxAddSlashesForSQL($title) . "',
            url='" . mxAddSlashesForSQL($url) . "',
            description='" . mxAddSlashesForSQL($description) . "',
			ort='" . mxAddSlashesForSQL($ort) . "',
            date='" . mxAddSlashesForSQL($updated) . "'
            WHERE lid = " . intval($lid));
        if ($ok) {
            sql_query("DELETE FROM " . $prefix . "_links_modrequest where requestid=" . intval($requestid));
            mxRedirect('admin.php?op=LinksModData&lid=' . $lid, _CHANGESAREOK);
        } else {
            mxErrorScreen('Database Error (modChangeModRequests)<br /><br />' . mysql_error());
        }
    } else {
        mxRedirect('admin.php?op=LinksListModRequests', 'ERROR: Recordset not found...', 5);
    }
}

/**
 * Beschreibung
 */
function modChangeIgnoreRequests($lid)
{
    global $prefix;
    $result = sql_query("delete from " . $prefix . "_links_modrequest where requestid=" . intval($lid));
    if ($result) {
        mxRedirect('admin.php?op=LinksListModRequests', _CHANGESAREOK);
    } else {
        mxErrorScreen('Database Error (modChangeIgnoreRequests)<br /><br />' . mysql_error());
    }
}

/**
 * Beschreibung
 */
function modCleanVotes()
{
    global $prefix, $module_name;
    if (!empty($_POST['okdelete'])) {
        $cid = (empty($_POST['cid'])) ? 0 : intval($_POST['cid']);
        if ($_POST['okdelete'] == _NO) {
            mxRedirect('admin.php?op=Links');
        }
        $totalvoteresult = sql_query("select distinct ratinglid FROM " . $prefix . "_links_votedata");
        while (list($lid) = sql_fetch_row($totalvoteresult)) {
            $voteresult = sql_query("select rating, ratinguser, ratingcomments FROM " . $prefix . "_links_votedata WHERE ratinglid = " . intval($lid));
            $totalvotesDB = sql_num_rows($voteresult);
            include ("modules/$module_name/includes/voteinclude.php");
            sql_query("UPDATE " . $prefix . "_links_links SET linkratingsummary=$finalrating,totalvotes=$totalvotesDB,totalcomments=$truecomments WHERE lid = $lid");
        }
        mxRedirect('admin.php?op=Links', _CHANGESAREOK);
    } else {
        include("header.php");
        modAdminMenu();
        OpenTableAl();
        echo "<div align=\"center\" class=\"option\">" . _CLEANLINKSDB . "</div><br /><br /><font class=\"content\">";
        echo _DELVOTEWARNING;
        echo '<div align="center"><br /><br />
        <form action="admin.php?op=Links" method="post">
        <input type="hidden" name="op" value="LinksCleanVotes" />
        <input type="submit" name="okdelete" value="' . _YES . '" />&nbsp;&nbsp;<input type="submit" name="okdelete" value="' . _NO . '" />
        </form></div>';
        CloseTableAl();
        include("footer.php");
    }
}

/**
 * Beschreibung
 */
function modModifyCat()
{
    global $prefix;
    $cid = intval($_REQUEST['cid']);
    $qry = "select cid, title, cdescription, parentid, captcha from " . $prefix . "_links_categories where cid=" . $cid;
    // mxDebugFuncVars($qry);
    $result = sql_query($qry);
    $cat = sql_fetch_assoc($result);
    include ("header.php");
    GraphicAdmin();
    modAdminMenu();
    OpenTable();
    echo "<fieldset><legend>" . _MODCATEGORY . "</legend>"
     . "<form method=\"post\" action=\"admin.php?op=LinksModCat&amp;cid=" . $cid . "\">"
     . "<table border=\"0\">"
     . modCategoryForm($cat)
     . "<tr valign=\"top\"><td colspan=\"2\">
    <input type=\"hidden\" name=\"cid\" value=\"" . $cid . "\" />
    <input type=\"hidden\" name=\"op\" value=\"LinksModCatSave\" />
    <input type=\"submit\" value=\"" . _SAVECHANGES . "\" />
    &nbsp;&nbsp;&nbsp;[&nbsp;<a href=\"admin.php?op=LinksDelCat&amp;cid=" . $cid . "\">" . _DELETE . "</a>&nbsp;]
    </td></tr>"
     . "</table>"
     . "</form></fieldset>";
    CloseTable();
    include("footer.php");
}

/**
 * Beschreibung
 */
function modAddCat()
{
    global $prefix;
    if (empty($_POST['parentid'])) {
        $_POST['parentid'] = 0;
    }
    $_POST['title'] = strip_tags(trim($_POST['title']));
    if (empty($_POST['title'])) {
        $error = _DOWNCATNOTITLE;
    } else {
        $result = sql_query("select cid from " . $prefix . "_links_categories where title='" . mxAddSlashesForSQL($_POST['title']) . "' AND parentid=" . intval($_POST['parentid']));
        if ((sql_num_rows($result))) {
            $error = _ERRORTHESUBCATEGORY . " <i>" . mxStripSlashes($_POST['title']) . "</i> " . _ALREADYEXIST;
        }
    }
    if (isset($error)) {
        include("header.php");
        GraphicAdmin();
        modAdminMenu();
        OpenTable();
        echo "<br /><center><font class=\"content\"><b>" . $error . "</b><br /><br />" . _GOBACK . "<br /><br /></center>";
        CloseTable();
        include("footer.php");
    } else {
        $result = sql_query("insert into " . $prefix . "_links_categories (title, cdescription, parentid, captcha) values ('" . mxAddSlashesForSQL($_POST['title']) . "', '" . mxAddSlashesForSQL($_POST['cdescription']) . "', '" . intval($_POST['parentid']) . "', '" . intval($_POST['captcha']) . "')");
        if ($result) {
            mxRedirect('admin.php?op=Links', _CHANGESAREOK);
        } else {
            mxErrorScreen('Database Error (modAddCat)<br /><br />' . mysql_error());
        }
    }
}

/**
 * Beschreibung
 */
function modModifyCatSave()
{
    global $prefix;
    $_POST['parentid'] = (empty($_POST['parentid'])) ? 0 : intval($_POST['parentid']);
    $_POST['title'] = trim(strip_tags(stripslashes($_POST['title'])));
    if (empty($_POST['title'])) {
        $error = _DOWNCATNOTITLE;
    } else if ($_POST['parentid'] == $_POST['cid']) {
        $error = _ERRORTHECATEGORY . ' &quot;' . $_POST['title'] . '&quot; == ' . _SUBCATEGORY . ' &quot;' . $_POST['title'] . '&quot;';
    } else {
        $result = sql_query("select count(cid) from " . $prefix . "_links_categories where title='" . mxAddSlashesForSQL($_POST['title']) . "' AND parentid=" . intval($_POST['parentid']) . " AND cid<>" . intval($_POST['cid']));
        list($exist) = sql_fetch_row($result);
        if ($exist) {
            $error = _ERRORTHESUBCATEGORY . " <i>" . mxStripSlashes($_POST['title']) . "</i> " . _ALREADYEXIST;
        }
    }
    if (isset($error)) {
        include("header.php");
        GraphicAdmin();
        modAdminMenu();
        OpenTable();
        echo "<br /><center><font class=\"content\"><b>" . $error . "</b><br /><br />" . _GOBACK . "<br /><br /></center>";
        CloseTable();
        include("footer.php");
    } else {
        $ok = sql_query("update " . $prefix . "_links_categories set title='" . mxAddSlashesForSQL($_POST['title']) . "', cdescription='" . mxAddSlashesForSQL($_POST['cdescription']) . "', parentid=" . intval($_POST['parentid']) . ", captcha=" . intval($_POST['captcha']) . " where cid=" . intval($_POST['cid']));
        if ($ok) {
            mxRedirect('admin.php?op=LinksModCat&amp;cid=' . intval($_POST['cid']), _CHANGESAREOK);
        } else {
            mxErrorScreen('Database Error (modModifyCatSave)<br /><br />' . mysql_error());
        }
    }
}

/**
 * Beschreibung
 */
function modDelCat()
{
    global $prefix;
    if (!empty($_POST['okdelete'])) {
        $cid = (empty($_POST['cid'])) ? 0 : intval($_POST['cid']);
        if ($_POST['okdelete'] == _NO) {
            mxRedirect('admin.php?op=LinksModCat&cid=' . intval($cid) . '');
        }
        // TODO: das taugt noch nix, der verknuepfte Kram muss noch geloescht werden
        sql_query("delete from " . $prefix . "_links_links where cid=" . intval($cid));
        // suppression des liens de cat?ries filles
        $result2 = sql_query("select cid from " . $prefix . "_links_categories where parentid=" . intval($cid));
        while (list($cid2) = sql_fetch_row($result2)) {
            sql_query("delete from " . $prefix . "_links_links where cid=" . intval($cid2));
        }
        sql_query("delete from " . $prefix . "_links_categories where parentid=" . intval($cid));
        sql_query("delete from " . $prefix . "_links_categories where cid=" . intval($cid));
        mxRedirect('admin.php?op=Links', _WLCATDELETED);
    } else {
        $cid = (empty($_REQUEST['cid'])) ? 0 : intval($_REQUEST['cid']);
        $result = sql_query("select count(cid) from " . $prefix . "_links_categories where parentid=" . intval($cid));
        list($nbsubcat) = sql_fetch_row($result);
        $nblink = modCountAll($cid);
        include("header.php");
        // GraphicAdmin();
        modAdminMenu();
        OpenTable();
        echo "<div align=\"center\" class=\"option\">" . _DELETECATEGORY . "</div><br /><br /><font class=\"content\">";
        echo _WLTHEREARE . " <b>" . $nbsubcat . "</b> " . _WLSUBCAT . " " . _WLATTACHEDTOCAT . '<br />';
        echo _WLTHEREARE . " <b>" . $nblink . "</b> " . _MODITEMS . " " . _WLATTACHEDTOCAT . '<br /><br />';
        echo _WLCATWARNING;
        echo '<div align="center"><br /><br />
        <form action="admin.php" method="post">
        <input type="hidden" name="op" value="LinksDelCat" />
        <input type="hidden" name="cid" value="' . $cid . '" />
        <input type="submit" name="okdelete" value="' . _YES . '" />&nbsp;&nbsp;<input type="submit" name="okdelete" value="' . _NO . '" />
        </form></div>';
        CloseTable();
        include("footer.php");
    }
}

/**
 * Beschreibung
 */
function modTransferToCat($cidfrom, $cidto)
{
    global $prefix;
    $result = sql_query("update " . $prefix . "_links_links set cid=" . intval($cidto) . " where cid=" . intval($cidfrom));
    if ($result) {
        mxRedirect('admin.php?op=Links', _CHANGESAREOK);
    } else {
        mxErrorScreen('Database Error (modTransferToCat)<br /><br />' . mysql_error());
    }
}

/**
 * Beschreibung
 */
function modDelData($lid)
{
    global $prefix;
    // mxDebugFuncVars($_REQUEST);
    $lid = (isset($_REQUEST['lid'])) ? intval($_REQUEST['lid']) : 0;
    if (!isset($_POST['okdelete'])) {
        include("header.php");
        $qry = "SELECT dd.*, dd.name as auth_name, dd.date as updated, dc.title AS ctitle, dc.parentid AS cparentid, de.linkid AS editorialid
            FROM " . $prefix . "_links_links AS dd
            LEFT JOIN " . $prefix . "_links_categories AS dc ON dd.cid = dc.cid
            LEFT JOIN " . $prefix . "_links_editorials AS de ON dd.lid = de.linkid
            WHERE dd.lid = " . intval($lid);
        $result = sql_query($qry);
        $row = sql_fetch_assoc($result);
        OpenTable();
        modViewData($row, 'single', 'full');
        CloseTable();
        echo '<br />';
        OpenTable();
        echo '<div align="center">' . _WLAREYOUSURE . '<br /><br />
        <form action="admin.php?op=LinksDelData" method="post">
        <input type="hidden" name="op" value="LinksDelData" />
        <input type="hidden" name="lid" value="' . $lid . '" />
        <input type="submit" name="okdelete" value="' . _YES . '" />&nbsp;&nbsp;<input type="submit" name="okdelete" value="' . _NO . '" />
        </form></div>';
        CloseTable();
        include("footer.php");
    } else {
        if ($_POST['okdelete'] != _YES || empty($lid)) {
            mxRedirect('admin.php?op=Links');
        } else {
            sql_query("delete from " . $prefix . "_links_links where lid=" . intval($lid));
            $notdeleted = modCheckAndCleanSubdata($lid);
            if ($notdeleted) {
                mxErrorScreen('Database Error (modDelData)<br /><br />' . mysql_error());
            } else {
                mxRedirect('admin.php?op=Links', _WLDELETED);
            }
        }
    }
}

/**
 * Beschreibung
 */
function modDelNew()
{
    global $prefix;
    // mxDebugFuncVars($_REQUEST);
    $lid = (isset($_REQUEST['lid'])) ? intval($_REQUEST['lid']) : 0;
    if (!isset($_POST['okdelete'])) {
        include("header.php");
        OpenTable();
        echo '<div align="center">' . _WLAREYOUSURE . '<br /><br />
        <form action="admin.php?op=LinksDelNew" method="post">
        <input type="hidden" name="op" value="LinksDelNew" />
        <input type="hidden" name="lid" value="' . $lid . '" />
        <input type="submit" name="okdelete" value="' . _YES . '" />&nbsp;&nbsp;<input type="submit" name="okdelete" value="' . _NO . '" />
        </form></div>';
        CloseTable();
        include("footer.php");
    } else {
        if ($_POST['okdelete'] != _YES || empty($lid)) {
            mxRedirect('admin.php?op=Links');
        } else {
            sql_query("delete from " . $prefix . "_links_newlink where lid=" . $lid);
            mxRedirect('admin.php?op=Links', _WLDELETED);
        }
    }
}

/**
 * Beschreibung
 */
function modAddEditorial($linkid, $editorialtitle, $editorialtext)
{
    global $aid, $prefix;
    $result = sql_query("insert into " . $prefix . "_links_editorials values (" . intval($linkid) . ", '" . mxAddSlashesForSQL($aid) . "', now(), '" . mxAddSlashesForSQL($editorialtext) . "', '" . mxAddSlashesForSQL($editorialtitle) . "')");
    if ($result) {
        mxRedirect('admin.php?op=LinksModData&lid=' . $linkid, _EDITORIALADDED, 3);
    } else {
        mxErrorScreen('Database Error (modAddEditorial)<br /><br />' . mysql_error());
    }
}

/**
 * Beschreibung
 */
function modModifyEditorial($linkid, $editorialtitle, $editorialtext)
{
    global $prefix;
    $result = sql_query("update " . $prefix . "_links_editorials set editorialtext='" . mxAddSlashesForSQL($editorialtext) . "', editorialtitle='" . mxAddSlashesForSQL($editorialtitle) . "' where linkid=" . intval($linkid));
    if ($result) {
        mxRedirect('admin.php?op=LinksModData&lid=' . $linkid, _EDITORIALMODIFIED, 3);
    } else {
        mxErrorScreen('Database Error (modModifyEditorial)<br /><br />' . mysql_error());
    }
}

/**
 * Beschreibung
 */
function modDelEditorial($linkid)
{
    global $prefix;
    $result = sql_query("delete from " . $prefix . "_links_editorials where linkid=" . intval($linkid));
    if ($result) {
        mxRedirect('admin.php?op=LinksModData&lid=' . $linkid, _EDITORIALREMOVED, 3);
    } else {
        mxErrorScreen('Database Error (modDelEditorial)<br /><br />' . mysql_error());
    }
}

/**
 * Beschreibung
 */
function modCheckResponse()
{
    // error_reporting(E_ALL);
    global $prefix, $module_name, $bgcolor1, $bgcolor2, $bgcolor3;
    // mxDebugFuncVars($_POST);
    $cids = (isset($_REQUEST['cids'])) ? $_REQUEST['cids'] : array(0);

    include ("header.php");
    GraphicAdmin();
    modAdminMenu();
    OpenTable();
    echo '<fieldset><legend>' . _LINKVALIDATION . '</legend>
    <form action="admin.php?op=LinksLinkCheck#result" method="post" name="jump" id="jump">
            <b>' . _CHECKCATEGORIES . '</b><br />
            <select name="cids[]" size="15" multiple>' . modGetCategoriesSelect($cids, 'showmain', 'hideemptycats') . '</select> <br />
            <input type="submit" value="' . _GO . '" />
            <input type="hidden" name="op" value="LinksLinkCheck" />
    </form>
    </fieldset>
    ';
    CloseTable();
    echo '<br />';
    // Ergebnisse
    if (isset($_REQUEST['cids']) && is_array($cids)) {
        @ini_set("max_execution_time", '0');
        @set_time_limit(0);

        $img_edit = mxCreateImage("modules/" . $module_name . "/images/edit.gif", _EDIT);
        $img_dele = mxCreateImage("modules/" . $module_name . "/images/delete.gif", _DELETE);
        $img_view = mxCreateImage("modules/" . $module_name . "/images/check.gif", _LINKVALIDATION);

        $cids = implode(',', $cids);
        $qry = "SELECT dd.*, dc.title AS ctitle, dc.parentid AS cparentid
            FROM " . $prefix . "_links_links AS dd
            LEFT JOIN " . $prefix . "_links_categories AS dc ON dd.cid = dc.cid
            WHERE dd.cid IN(" . $cids . ")
            ORDER BY dd.cid, dd.title";
        $result = sql_query($qry);
        $lastcid = '--dummy--';
        $colorswitch = $bgcolor1;
        while ($row = sql_fetch_assoc($result)) {
            if ($colorswitch == $bgcolor3) {
                $colorswitch = $bgcolor1;
            } else {
                $colorswitch = $bgcolor3;
            }
            // wenn andere Kategorie als vorher
            if ($row['cid'] !== $lastcid) {
                $cattitle = (empty($row['ctitle'])) ? 'HIDDEN (' . _LINKSMAINCAT . ')' : modGetParentTitles($row['cparentid'], $row['ctitle']);
                // Zwischenueberschrift ausgeben und $lastsid zuruecksetzen
                $rows[] = '<tr style="background-color: ' . $colorswitch . ';"><td colspan="5">' . _VALIDATINGCAT . ': <b>' . $cattitle . '</b></td></tr>';
                $rows[] = '<tr style="background-color: ' . $colorswitch . ';">
                        <th colspan="3">' . _STATUS . '</th>
                        <th>' . _LINKTITLE . '</th>
                        <th width="10%">' . _FUNCTIONS . '</th>
                        </tr>';
                $lastcid = $row['cid'];
                if ($colorswitch == $bgcolor3) {
                    $colorswitch = $bgcolor1;
                } else {
                    $colorswitch = $bgcolor3;
                }
            }
            clearstatcache();
            $header = get_response_header($row['url']);
            if ($header['status'] >= 200 && $header['status'] < 300 && $header['type']) {
                $status = '<div style="background-color: Green; color: Yellow; padding: 2px;">' . _OK . '</div>';
            } else if (($header['status'] > 0 && $header['status'] < 200) || ($header['status'] >= 300 && $header['status'] < 400)) {
                $status = '??';
            } else {
                $status = '<div style="background-color: Red; color: Yellow; padding: 2px;">' . _FAILED . '</div>';
            }
            $detail = '<a href="modules.php?name=' . $module_name . '&amp;op=check&amp;url=' . urlencode($row['url']) . '"' . modCheckPopupLink($row['url']) . '>' . $img_view . '</a>';
            $rows[] = '<tr style="background-color: ' . $colorswitch . ';">
            <th width="1%">' . $status . '</th>
            <td width="1%">' . $header['status'] . '</td>
            <th width="1%">' . $detail . '</th>
            <td><a href="' . $row['url'] . '" target="_blank">' . $row['title'] . '</a></td>
            <th>
                <a href="admin.php?op=LinksModData&amp;lid=' . $row['lid'] . '">' . $img_edit . '</a> &nbsp;&nbsp;
                <a href="admin.php?op=LinksDelData&amp;lid=' . $row['lid'] . '">' . $img_dele . '</a>
            </th>
            </tr>';
        } // end while
        echo '<a name="result" id="result"></a>';
        OpenTable();
        if (isset($rows)) {
            echo '<table width="100%" border="0" cellspacing="1" cellpadding="2" style="background-color: ' . $bgcolor2 . ';">' . implode("\n", $rows) . '</table>';
        } else {
            echo '<h3>' . _NOTHINGINVIEW . '</h3>';
        }
        CloseTable();
        echo '<br />';
    }
    include ("footer.php");
}

/**
 * Beschreibung
 */
function modAddNewData()
{
    global $prefix, $module_name;

    $_POST = modCheckData($_POST);

    if (count($_POST['msg'])) {
        include("header.php");
        GraphicAdmin();
        modAdminMenu();
        OpenTable();
        echo "<center><b>" . implode('<br />', $_POST['msg']) . "</b><br /><br />" . _GOBACK . "</center>";
        CloseTable();
        include("footer.php");
        exit;
    }

    $qry = "INSERT INTO " . $prefix . "_links_links SET
        cid=" . intval($_POST['cid']) . ",
        sid=0,
        title='" . mxAddSlashesForSQL($_POST['title']) . "',
        url='" . mxAddSlashesForSQL($_POST['url']) . "',
        description='" . mxAddSlashesForSQL($_POST['description']) . "',
		ort='" . mxAddSlashesForSQL($_POST['ort']) . "',
        name='" . mxAddSlashesForSQL($_POST['auth_name']) . "',
        email='" . mxAddSlashesForSQL($_POST['email']) . "',
        submitter='" . mxAddSlashesForSQL($_POST['submitter']) . "',
        hits=" . intval($_POST['hits']) . ",
        date='" . mxAddSlashesForSQL($_POST['updated']) . "'
		        ";
    $result = sql_query($qry);
    if ($result) {
        $newlid = sql_insert_id();
        if (!empty($_POST['new'])) {
            sql_query("delete from " . $prefix . "_links_newlink where lid=" . intval($_POST['lid']));
        }
        // Automatisch einen News-Artikel erstellen
        if (!empty($_POST['addstory'])) {
            $admindata = mxGetAdminSession();
            if (!empty($_POST['submitter'])) {
                $submitterdata = mxGetUserDataFromUsername($_POST['submitter']);
                if (empty($submitterdata['uname'])) {
                    $uid = 0;
                    $uname = strip_tags($_POST['submitter']);
                    $stuserlink = $uname;
                } else {
                    $uid = $submitterdata['uid'];
                    $uname = $submitterdata['uname'];
                    $stuserlink = mxCreateUserprofileLink($uname);
                }
            } else {
                $uid = 0;
                $uname = $GLOBALS['anonymous'];
                $stuserlink = $GLOBALS['anonymous'];
            }

            $stmsg = '<br />' . $stuserlink . ' ' . _DANNO1;
            $stmsg .= '<br />' . _DANNO2 . ' <b>' . $_POST['title'] . '</b>' . (_DANNO3 == '') ? '' : ' ' . _DANNO3;
            $stmsg .= '<br /><br />' . _DANNO4;
            $stmsg .= '<br /><br /><b>' . _WLDESCRIPTION . '</b>:<br />';
            $stmsg .= $_POST['description'] . '<br /><br />';
            $stmsg .= '<a href="modules.php?name=' . $module_name . '&amp;op=view&amp;lid=' . $newlid . '">' . _DANNO5 . '</a>';
            // ACHTUNG! html_entity_decode von PHP 4.3.0 macht Probleme!
            // Daher mxHtmlEntityDecode nehmen!
            // by AK
            $title = mxHtmlEntityDecode($_POST['title']);
            $stmsg = mxHtmlEntityDecode($stmsg);
            // mxDebugFuncVars($stmsg);
            // diese Abfrage verwenden, um die Story direkt einzufuegen
            // $qry = "insert into ".$prefix."_stories (catid,aid,title,time,hometext,topic, counter, informant) values (2,'".mxAddSlashesForSQL($admindata['aid'])."','".mxAddSlashesForSQL($title)."',now(),'".mxAddSlashesForSQL($stmsg)."',2, 0,'".mxAddSlashesForSQL($uname)."')";
            $qry = "insert into " . $prefix . "_queue (uid,uname,subject,story,timestamp) values ('" . $uid . "','" . mxAddSlashesForSQL($uname) . "','" . mxAddSlashesForSQL($title) . "','" . mxAddSlashesForSQL($stmsg) . "',now())";
            sql_query($qry);
        }
        // end Hack um automatisch eine Story zu erstellen
        mxRedirect('admin.php?op=Links', _NEWLINKADDED, 3);
    } else {
        mxErrorScreen('Database Error (modAddNewData)<br /><br />' . mysql_error());
    }
}

/**
 * Configuration Functions to Setup all the Variables
 */
function modConfig()
{
    global $module_name;
    include ("modules/" . $module_name . "/l_config.php");
    include ("header.php");
    GraphicAdmin();
    modAdminMenu();

    OpenTable();
    echo '<fieldset><legend>' . _WLINKADMINHEAD . '</legend>
    <form action="admin.php?op=LinksConfig" method="post">
    <table border="0" cellspacing="0" cellpadding="2">
    <tr>
        <td width="83%">' . _BLOCKSHOW_RIGHT . ':</td>
        <td style="white-space: nowrap;"><input type="radio" name="lindex" value="1"' . ((empty($lindex)) ? '' : ' checked="checked"') . ' />&nbsp;' . _YES . '&nbsp;<input type="radio" name="lindex" value="0"' . ((empty($lindex)) ? ' checked="checked"' : '') . ' />&nbsp;' . _NO . ' </td>
    </tr>
    <tr>
        <td>' . _SHOWQUICKJUMPER . ':</td>
        <td><input type="radio" name="showquickjump" value="1"' . ((empty($showquickjump)) ? '' : ' checked="checked"') . ' />&nbsp;' . _YES . '&nbsp;<input type="radio" name="showquickjump" value="0"' . ((empty($showquickjump)) ? ' checked="checked"' : '') . ' />&nbsp;' . _NO . ' </td>
    </tr>
    <tr>
        <td>' . _COUNTCATCOLS . ':</td>
        <td><input type="text" name="catcols" value="' . ((empty($catcols) || intval($catcols) < 1) ? 1 : intval($catcols)) . '"  size="2" maxlength="1" /> </td>
    </tr>
    <tr>
        <td>' . _SORTCATCOLS . ':</td>
        <td><select name="catsort"> <option value="0"' . ((empty($catsort)) ? ' selected="selected"': '') . '>' . _SORTCATCOLS_1 . '</option> <option value="1"' . ((!empty($catsort)) ? ' selected="selected"': '') . '>' . _SORTCATCOLS_2 . '</option> </select> </td>
    </tr>
    <tr>
        <td>' . _SHOWCOUNTERS . ':</td>
        <td><input type="radio" name="showcounters" value="1"' . ((empty($showcounters)) ? '' : ' checked="checked"') . ' />&nbsp;' . _YES . '&nbsp;<input type="radio" name="showcounters" value="0"' . ((empty($showcounters)) ? ' checked="checked"' : '') . ' />&nbsp;' . _NO . ' </td>
    </tr>
    <tr>
        <td>' . _SHOWEMPTYCATS . ':</td>
        <td><input type="radio" name="showemptycategories" value="1"' . ((empty($showemptycategories)) ? '' : ' checked="checked"') . ' />&nbsp;' . _YES . '&nbsp;<input type="radio" name="showemptycategories" value="0"' . ((empty($showemptycategories)) ? ' checked="checked"' : '') . ' />&nbsp;' . _NO . ' </td>
    </tr>
    <tr><td colspan="2"><hr noshade="noshade" size="1" /></td>
    </tr>
    <tr>
        <td>' . _PERPAGE . ':</td>
        <td><input type="text" name="perpage" value="' . $perpage . '" size="3" maxlength="2" /> </td>
    </tr>
    <tr>
        <td>' . _NEWLINK . ':</td>
        <td><input type="text" name="newlinks" value="' . $newlinks . '" size="3" maxlength="2" /> </td>
    </tr>
    <tr>
        <td>' . _LINKRESULTS . ':</td>
        <td><input type="text" name="linksresults" value="' . $linksresults . '" size="3" maxlength="2" /> </td>
    </tr>
    <tr>
        <td>' . _SHOWDETAILS . ':</td>
        <td><input type="radio" name="showdetails" value="1"' . ((empty($showdetails)) ? '' : ' checked="checked"') . ' />&nbsp;' . _YES . '&nbsp;<input type="radio" name="showdetails" value="0"' . ((empty($showdetails)) ? ' checked="checked"' : '') . ' />&nbsp;' . _NO . ' </td>
    </tr>
    <tr><td colspan="2"><hr noshade="noshade" size="1" /></td>
    </tr>
    <tr>
        <td>' . _USERATING . '</td>
        <td> <input type="radio" name="usevoting" value="1" ' . ((!empty($usevoting)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="usevoting" value="0"' . ((empty($usevoting)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    <tr>
        <td>' . _USEOUTSIDEVOTING . '</td>
        <td> <input type="radio" name="useoutsidevoting" value="1" ' . ((!empty($useoutsidevoting)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="useoutsidevoting" value="0"' . ((empty($useoutsidevoting)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    <tr>
        <td>' . _ANONWAITDAYS . ':</td>
        <td><input type="text" name="anonwaitdays" value="' . $anonwaitdays . '" size="4" maxlength="4" /> </td>
    </tr>
    <tr>
        <td>' . _OUTSIDEWAITDAYS . ':</td>
        <td><input type="text" name="outsidewaitdays" value="' . $outsidewaitdays . '" size="4" maxlength="4" /> </td>
    </tr>
    <tr>
        <td>' . _ANONWEIGHT . ':</td>
        <td><input type="text" name="anonweight" value="' . $anonweight . '" size="4" maxlength="4" /> </td>
    </tr>
    <tr>
        <td>' . _OUTSIDEWEIGHT . ':</td>
        <td><input type="text" name="outsideweight" value="' . $outsideweight . '" size="4" maxlength="4" /> </td>
    </tr>
    <tr>
        <td>' . _DETAILVOTEDECIMAL . ':</td>
        <td><input type="text" name="detailvotedecimal" value="' . $detailvotedecimal . '" size="4" maxlength="4" /> </td>
    </tr>
    <tr>
        <td>' . _MAINVOTEDECIMAL . ':</td>
        <td><input type="text" name="mainvotedecimal" value="' . $mainvotedecimal . '" size="4" maxlength="4" /> </td>
    </tr>
    <tr>
        <td>' . _LINKVOTEMIN . ':</td>
        <td><input type="text" name="linkvotemin" value="' . $linkvotemin . '" size="10" maxlength="10" /> </td>
    </tr>
    <tr>
        <td>' . _TOPRATEDPERCENTTRIGGER . '</td>
        <td> <input type="radio" name="toplinkspercentrigger" value="1" ' . ((!empty($toplinkspercentrigger)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="toplinkspercentrigger" value="0"' . ((empty($toplinkspercentrigger)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    <tr>
        <td>' . _TOPRATEDCOUNT . ':</td>
        <td><input type="text" name="toplinks" value="' . $toplinks . '" size="4" maxlength="4" /> </td>
    </tr>
    <tr>
        <td>' . _USECOMMENTS . '</td>
        <td> <input type="radio" name="usecomments" value="1" ' . ((!empty($usecomments)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="usecomments" value="0"' . ((empty($usecomments)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    <tr><td colspan="2"><hr noshade="noshade" size="1" /></td>
    </tr>
    <tr>
        <td>' . _POPULAR . ':</td>
        <td><input type="text" name="popular" value="' . $popular . '" size="10" maxlength="10" /> </td>
    </tr>
    <tr>
        <td>' . _MOSTPOPLINKPERCENTTRIGGER . '</td>
        <td> <input type="radio" name="mostpoplinkspercentrigger" value="1" ' . ((!empty($mostpoplinkspercentrigger)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="mostpoplinkspercentrigger" value="0"' . ((empty($mostpoplinkspercentrigger)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    <tr>
        <td>' . _MOSTPOPLINK . ':</td>
        <td><input type="text" name="mostpoplinks" value="' . $mostpoplinks . '" size="4" maxlength="4" /> </td>
    </tr>
    <tr><td colspan="2"><hr noshade="noshade" size="1" /></td>
    </tr>
    <tr>
        <td>' . _ADDLINK . '</td>
        <td> <input type="radio" name="user_addlink" value="1" ' . ((!empty($user_addlink)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="user_addlink" value="0"' . ((empty($user_addlink)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    <tr>
        <td>' . _ANONADDLINKLOCK . '</td>
        <td> <input type="radio" name="link_anonaddlinklock" value="1" ' . ((!empty($link_anonaddlinklock)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="link_anonaddlinklock" value="0"' . ((empty($link_anonaddlinklock)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    <tr>
        <td>' . _BLOCKUNREGMODIFY . '</td>
        <td> <input type="radio" name="blockunregmodify" value="1" ' . ((!empty($blockunregmodify)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="blockunregmodify" value="0"' . ((empty($blockunregmodify)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    <tr>
        <td>' . _NOTIFYSUBMISSION . '</td>
        <td> <input type="radio" name="linknotify" value="1" ' . ((!empty($linknotify)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="linknotify" value="0"' . ((empty($linknotify)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    </table><br /><br />
    <input type="hidden" name="op" value="LinksConfigSave" size=20 />
    <center><input type="submit" value="' . _SAVECHANGES . '" size=20 /></center>
    </form>
    </fieldset>';
    CloseTable();
    include ("footer.php");
    /*
    <tr>
        <td>' . _ADDNEWS . '</td>
        <td> <input type="radio" name="downnews" value="1" '.((!empty($downnews)) ? ' checked="checked"': '').' />' . _YES . '&nbsp; <input type="radio" name="downnews" value="0"'.((empty($downnews)) ? ' checked="checked"': '').' />' . _NO .'</td>
    </tr>
     */
}

/**
 * Beschreibung
 */
function modConfigSave()
{
    global $module_name;
    foreach ($_POST as $key => $value) {
        $_POST[$key] = intval($value);
    }
    extract($_POST);
    $anonweight = ($anonweight < 1) ? 1 : $anonweight;
    $catcols = ($catcols < 1) ? 1 : $catcols;

    $content = "<?php\n";
    $content .= "/************************************\n";
    $content .= " pragmaMx - Web Content Management System\n";
    $content .= " Copyright by pragmaMx Developer Team - http://www.pragmamx.org\n";
    $content .= " write with: \$Id: admin.php,v 1.18 2009/02/26 06:38:30 tora60 Exp $\n";
    $content .= "************************************/\n\n";
    $content .= "\$lindex = '$lindex';\n";
    $content .= "\$perpage = '$perpage';\n";
    $content .= "\$popular = '$popular';\n";
    $content .= "\$newlinks = '$newlinks';\n";
    $content .= "\$toplinks = '$toplinks';\n";
    $content .= "\$linksresults = '$linksresults';\n";
    $content .= "\$link_anonaddlinklock = '$link_anonaddlinklock';\n";
    $content .= "\$anonwaitdays = '$anonwaitdays';\n";
    $content .= "\$outsidewaitdays = '$outsidewaitdays';\n";
    $content .= "\$useoutsidevoting = '$useoutsidevoting';\n";
    $content .= "\$anonweight = '$anonweight';\n";
    $content .= "\$outsideweight = '$outsideweight';\n";
    $content .= "\$detailvotedecimal = '$detailvotedecimal';\n";
    $content .= "\$mainvotedecimal = '$mainvotedecimal';\n";
    $content .= "\$toplinkspercentrigger = '$toplinkspercentrigger';\n";
    $content .= "\$toplinks = '$toplinks';\n";
    $content .= "\$mostpoplinkspercentrigger = '$mostpoplinkspercentrigger';\n";
    $content .= "\$mostpoplinks = '$mostpoplinks';\n";
    $content .= "\$linkvotemin = '$linkvotemin';\n";
    $content .= "\$blockunregmodify = '$blockunregmodify';\n";
    $content .= "\$user_addlink = '$user_addlink';\n";
    $content .= "\$linknotify = '$linknotify';\n";
    $content .= "\$showcounters = '$showcounters';\n";
    $content .= "\$showdetails = '$showdetails';\n";
    $content .= "\$showquickjump = '$showquickjump';\n";
    $content .= "\$showemptycategories = '$showemptycategories';\n";
    $content .= "\$catcols = '$catcols';\n";
    $content .= "\$catsort = '$catsort';\n";
    $content .= "\$usecomments = '$usecomments';\n";
    $content .= "\$usevoting = '$usevoting';\n";
    // $content .= "\$hidepath = '$hidepath';\n";
    $content .= "\n";
    $content .= "?>";
    $conffile = "modules/" . $module_name . "/l_config.php";
    @chmod($conffile, 0777);
    $file = @fopen($conffile, "w");
    if ($file) {
        fwrite($file, $content);
        fclose($file);
        $msg = _CHANGESAREOK;
        $delay = 0;
    } else {
        $msg = _CHANGESNOTOK;
        $delay = 5;
    }
    @chmod($conffile, 0444);
    mxRedirect('admin.php?op=LinksConfig', $msg, $delay);
}

switch ($op) {
    case "links": // Kompatibilitaet
    case "Links":
        modAdminMain();
        break;

    case "LinksList":
        modList();
        break;

    case "LinksDelNew":
        modDelNew();
        break;

    case "LinksAddCat":
        modAddCat($title, $cdescription);
        break;

    case "LinksAddData":
        modAddNewData();
        break;

    case "LinksAddEditorial":
        modAddEditorial($linkid, $editorialtitle, $editorialtext);
        break;

    case "LinksModEditorial":
        modModifyEditorial($linkid, $editorialtitle, $editorialtext);
        break;

    case "LinksLinkCheck":
    case "LinksValidate":
        modCheckResponse();
        break;

    case "LinksDelEditorial":
        modDelEditorial($linkid);
        break;

    case "LinksCleanVotes":
        modCleanVotes();
        break;

    case "LinksListBrokenLinks":
    case "LinksListBroken":
        modListBroken();
        break;

    case "LinksDelBroken":
        modDelBroken($lid);
        break;

    case "LinksIgnoreBroken":
        modIgnoreBroken($lid);
        break;

    case "LinksListModRequests":
        modListModRequests();
        break;

    case "LinksChangeModRequests":
        modChangeModRequests($requestid);
        break;

    case "LinksChangeIgnoreRequests":
        modChangeIgnoreRequests($requestid);
        break;

    case "LinksDelCat":
        modDelCat();
        break;

    case "LinksModCat":
        modModifyCat();
        break;

    case "LinksModCatSave":
        modModifyCatSave();
        break;

    case "LinksModData":
        modModifyData($lid);
        break;

    case "LinksModDataSave":
        modModifyDataSave();
        break;

    case "LinksDelData":
        modDelData($lid);
        break;

    case "LinksDelVote":
        modDelVote($lid, $rid);
        break;

    case "LinksDelComment":
        modDelComment($lid, $rid);
        break;

    case "LinksTransfer":
        modTransferToCat($cidfrom, $cidto);
        break;

    case "LinksConfig":
        modConfig();
        break;

    case "LinksConfigSave":
        modConfigSave();
        break;
}

?>