<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.9 $
 * $Author: tora60 $
 * $Date: 2008/10/06 17:19:22 $
 *
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 * Based on Journey Links Hack
 * Copyright (c) 2000 by James Knickelbein
 * Journey Milwaukee (http://www.journeymilwaukee.com)
 */

defined('mxMainFileLoaded') or die('access denied');

require(PMX_SYSTEM_DIR . DS . 'captcha/settings.php');
$weblinkson = (($weblinkson) && ((!MX_IS_USER) || ((MX_IS_USER) && ($captchauseron))) && (!MX_IS_ADMIN)) ? 1 : 0;
// $weblinkson = false;
$wysiwyg = 0;
$wysiwyg_linx = 0;
$wysiwyg_comments = 0;
include_once('spaw/spaw_control.class.php');

function AddLink($pvs = array())
{
    global $prefix, $module_name, $pagetitle;
    if (MX_IS_USER) {
        $udata = mxGetUserData();
    }
    // Daten fuer header aufbereiten
    $title = _ADDNEWLINK;
    $pagetitle = strip_tags($title);

    include(PMX_MODULES_DIR . DS . $module_name . '/includes/header.php');
    if (!empty($pvs['msg'])) {
        openTableAl();
        echo '<div style="text-align: left;"><h2>' . _ERROROCCURS . '</h2><ul><li>' . implode('</li><li>', $pvs['msg']) . '</li></ul></div>';
        closeTableAl();
        echo '<br />';
    }
    OpenTable();
    if (MX_IS_USER || $GLOBALS['link_anonaddlinklock'] != 1 || mxGetAdminPref("radminlink")) {
        if (empty($pvs)) {
            $pvs['submitter'] = (isset($udata['uname'])) ? $udata['uname'] : $GLOBALS['anonymous'] ;
            $pvs['cid'] = (isset($_REQUEST['cid'])) ? intval($_REQUEST['cid']) : 0;
        }
        echo "<form method=\"post\" action=\"modules.php?name=" . $module_name . "&amp;op=Add\" name=\"downform\">"
         . "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
         . "<tr><td colspan=\"2\"><b>" . _INSTRUCTIONS . ":</b><br />"
         . "<strong><big>&middot;</big></strong> " . _DSUBMITONCE . '<br />'
         . "<strong><big>&middot;</big></strong> " . _DPOSTPENDING . '<br />'
         . "<strong><big>&middot;</big></strong> " . _USERANDIP . "<br /><br /></td></tr>"
         . modDataForm($pvs, 'AddLink')
         . "<tr valign=\"top\"><td colspan=\"2\" align=\"center\"><input type=\"hidden\" name=\"op\" value=\"Add\">"
         . "<br /><br /><input type=\"submit\" value=\"" . _WLADDLINK . "\"></td></tr>"
         . "</table>"
         . "</form>";
    } else {
        echo modMessageNoAnonPost('AddLink');
    }
    CloseTable();
    include(PMX_MODULES_DIR . DS . $module_name . '/includes/footer.php');
}

function Add()
{
    global $prefix, $module_name, $linknotify;
    mxStripSlashes($_POST);
    if (MX_IS_USER) {
        $udata = mxGetUserData();
    }
    if (!MX_IS_USER && $GLOBALS['link_anonaddlinklock'] == 1 && !mxGetAdminPref("radminlink")) {
        mxErrorScreen(modMessageNoAnonPost('AddLink'));
    }
    // feed submitter var
    $_POST['submitter'] = (!empty($udata['uname'])) ? $udata['uname'] : $GLOBALS['anonymous'] ;

    $_POST = modCheckData($_POST);

    if (count($_POST['msg'])) {
        AddLink(mxStripSlashes($_POST));
        exit;
    }

    $qry = "INSERT INTO " . $prefix . "_links_newlink SET
        cid=" . intval($_POST['cid']) . ",
        title='" . mxAddSlashesForSQL($_POST['title']) . "',
        url='" . mxAddSlashesForSQL($_POST['url']) . "',
        description='" . mxAddSlashesForSQL($_POST['description']) . "',
		ort='" . mxAddSlashesForSQL($_POST['ort']) . "',
        name='" . mxAddSlashesForSQL($_POST['auth_name']) . "',
        email='" . mxAddSlashesForSQL($_POST['email']) . "',
        submitter='" . mxAddSlashesForSQL($_POST['submitter']) . "',
        updated='" . mxAddSlashesForSQL($_POST['updated']) . "'
        ";
    if (sql_query($qry)) {
        // mail an admin senden
        if ($linknotify) {
            $link = PMX_HOME_URL . '/admin.php?op=Links#waiting';
            $notify_message = mxHtmlEntityDecode("-- " . _MODUNAME . " --\n" . $GLOBALS['notify_message'] . "\n\n========================================================\n" . $link . "\n\nat: " . strftime(_SHORTDATESTRING . ' %H:%M', time()) . "\nip/ip:" . MX_REMOTE_ADDR . "\nfrom: " . $_POST['submitter'] . "\n");
            mxMail($GLOBALS['notify_email'], mxHtmlEntityDecode($GLOBALS['notify_subject'] . ' (' . _MODUNAME . ')'), $notify_message, $GLOBALS['notify_from'], "text");
        }
        mxRedirect('modules.php?name=' . $module_name . '&amp;cid=' . intval($_POST['cid']), "<b>" . _LINKRECEIVED . "</b><br /><br />" . _CHECKFORIT . '<br />', 10);
    } else {
        mxErrorScreen('Database-Error');
    }
}

function modMessageNoAnonPost($op)
{
    global $module_name;
    $out = '<div align="left">'
     . _LINKSNOTUSER1 . '<br />'
     . _LINKSNOTUSER2 . '<br /><br />'
     . _LINKSNOTUSER3 . '<br /><br />'
     . _LINKSNOTUSER4 . '<br />'
     . _LINKSNOTUSER5 . ' '
     . _LINKSNOTUSER6 . '<br />'
     . _LINKSNOTUSER7 . '<br /><br />'
     . '<center>';
    if (mxModuleAllowed('Your_Account')) {
        $out .= '&nbsp;<a rel="nofollow" href="modules.php?name=Your_Account&amp;redirect=' . urlencode('modules.php?name=' . $module_name . '&op=' . $op . '') . '">' . _LOGIN . '</a>&nbsp;';
    }
    if (mxModuleAllowed('User_Registration')) {
        $out .= '&nbsp;<a rel="nofollow" href="modules.php?name=User_Registration">' . _LINKSNOTUSER8 . '</a>&nbsp;';
    }
    $out .= '</div>';
    return $out;
}

?>